#ifndef DATABASEH
#define DATABASEH
//---------------------------------------------------------------------------
#include <windows.h>
#include <vector>
#include <String>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <io.h>
#include <stdio.h>
#include "node.hpp"
using namespace std;
//---------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////
//JNX
class Column
{
public:
    string   table;//擾e[u
    string   name; //J
    string   alias;//GCAX
    dataType type; //f[^^
    //JRXgN^
    Column(void);
    Column(const string tbl, const string nam, const dataType typ=STRING);
    Column(const Column* clm);
    void AddAlias(const string myalias);
    //e[uLlvI select = TableName.ColumnName
    int CompareAlias( string select, const map<string,string>& clmalias, const map<string,string>& tblalias);
    int Compare( string select, map<string,string>& clmalias, map<string,string>& tblalias);
    int SaveToFile(int fd);
    int LoadFromFile(int fd);
};
/////////////////////////////////////////////////////////////////////////////
//e[uNX
class Table
{
public:
    string          name;         //e[u
    string          alias;        //e[uGCAX
    vector<Column*> column;       //J
    vector<Node*>   node;         //em[h
    vector<int>     index;        //orderbỹtB^
    int             ref;          //read thread
#ifdef linux
    pthread_mutex_t mutex;        //NeBJZbVmutex
#else
    CRITICAL_SECTION cs;          //NeBJZNV
#endif
    //RXgN^
    //myname:e[u
    //mycolumn:J
    void cd(void);
    //ZbVǗ
    void readStart();
    void readEnd();
    void writeStart();
    void writeEnd();
    //ev[g
    Table(void);
    //CSVe[u쐬
    Table(char* myname, char* mycolumn);
    //Stringz񂩂e[u쐬
    Table(const string myname, const vector<string>& mycolumn);
    //J񂩂e[u쐬
    Table(const string myname, const vector<Column*> mycolumn);
    void copy(Table* tbl);
    //fXgN^
    ~Table();
    //GCAXݒ
    int setAlias(const vector<string>& colnams,const vector<string>& colalias,const vector<string>& tables, const vector<string>& tblalias);
    //e[uf[^擾
    vector<Node*> getTable(void);
    //e[uCT[g(CSV)
    //JĂȂ`FbNĂȂ̂ŎcNULLǉ
    int Insert(const char* data);
    //Jƃf[^w
    int Table::Insert(const vector<string>& clm,const vector<string>& data);
    //e[uCT[g
    int Insert(const vector<char*>& data);
    //e[uI
    Table* Select(const char* selection);
    //e[uI
    Table* Select(const vector<string>& colnums,map<string,string>& clmalias, map<string,string>& tblalias);
    //בւ
    Table* OrderBy(string targetColumn,map<string,string>& clmalias, map<string,string>& tblalias,orderType type=ASC);
    //e[uɃJǉ
    void AddColumn(vector<Column*> addColumn);
    //Left join
    Table* LeftJoin(Table* joinTable,const vector<string>& cond);
    //intersection
    Table* Intersection(Table* Table2);
    //z񐶐
    int condition_mat(const vector<string>& cond, map<string,string>& clmalias, map<string,string>& tblalias, vector<char>& mat);
    //e[ui
    Table* Where(const vector<string>& cond,map<string,string>& clmalias, map<string,string>& tblalias);
    //r
    int compare(const string arg1, const string op , const string arg2, const dataType type );
    //e[uXV
    int Table::Update(const vector<string>& colnams,const vector<string>& values,const vector<string>& cond,map<string,string>& clmalias, map<string,string>& tblalias);
    //e[u폜
    int Table::Delete(const vector<string>& cond,map<string,string>& clmalias, map<string,string>& tblalias);
    //VACY
    string toString(void);
    //A
    int LoadFromFile(int fd);
    //ۑ
    int SaveToFile(int fd);
};
/////////////////////////////////////////////////////////////////////////////
typedef enum     {TXSELECT,TXCREATE,TXINSERT,TXUPDATE,TXDELETE,TXDROP,TXFROM,TXINTO,TXWHERE,TXSHOW,TXORDER,TXBY,TXSET,TXTABLES,TXTBL  ,TXDATABASES,TXDATABASE,TXVALUES,TXQUIT,TXUSE,TXAND,TXOR,TXAS,TXPS,TXPE,TXCM,TXED,TXHELP,TXARG=99,TXNONE=-1} CTYP;
char   ccmd[][9]={"select","create","insert","update","delete","drop","from","into","where","show","order","by","set","tables","table","databases","database","values","quit","use","and","or","as","(" , ")", ",", ";","help"};
CTYP   ctyp[]   ={TXSELECT,TXCREATE,TXINSERT,TXUPDATE,TXDELETE,TXDROP,TXFROM,TXINTO,TXWHERE,TXSHOW,TXORDER,TXBY,TXSET,TXTABLES,TXTBL  ,TXDATABASES,TXDATABASE,TXVALUES,TXQUIT,TXUSE,TXAND,TXOR,TXAS,TXPS,TXPE,TXCM,TXED,TXHELP,TXARG,TXNONE};
int    clen[]   ={       6,       6,       6,       6,       6,      4,    4,     4,      5,     4,      5,   2,    3,       6,      5,         9,          8,       6,     4,    3,    3,   2,   2,   1,   1,   1,   1,     4};  
size_t flen = sizeof(clen)/sizeof(clen[0]);
extern int getToken(unsigned char* sql, unsigned char* token);
extern int chkToken(unsigned char* sql, unsigned char* token, CTYP cmd);

/////////////////////////////////////////////////////////////////////////////
class Database
{
public:
    string name;
    map<string,Table*> tbllist;
    int ref;
    ////////////////////////////////////////////////////////////////////////////
    Database(string myname);
    ////////////////////////////////////////////////////////////////////////////
    ~Database(void);
    ////////////////////////////////////////////////////////////////////////////
    Table* SQL(unsigned char* sql);
    ////////////////////////////////////////////////////////////////////////////
    int LoadFromFile(string file);
    ////////////////////////////////////////////////////////////////////////////
    int SaveToFile(string file);
};
#define CATFILE "_cybeleDBcat"
/////////////////////////////////////////////////////////////////////////////
class DBCatalog
{
public:
    int refs;
    map<string,Database*> dblist;
    map<int,Database*> dbHandle;
    ////////////////////////////////////////////////////////////////////////////
    //VOg擾
    static DBCatalog& getInstance(void);
    ////////////////////////////////////////////////////////////////////////////
    //f[^x[Xɐڑ
    Database* DBConnect(char* DBName);
    ////////////////////////////////////////////////////////////////////////////
    //VKDB쐬
    Database* DBCreate(char* DBName);
    ////////////////////////////////////////////////////////////////////////////
    //DBN[Y
    void DBClose(char* DBName);
    ////////////////////////////////////////////////////////////////////////////
    size_t ShowCatalog(void);
    ////////////////////////////////////////////////////////////////////////////
    int LoadFromFile(void);
    ////////////////////////////////////////////////////////////////////////////
    int SaveToFile(void);
    ////////////////////////////////////////////////////////////////////////////
    DBCatalog(void);
    ////////////////////////////////////////////////////////////////////////////
    ~DBCatalog(void);
};
static DBCatalog &catalog = DBCatalog::getInstance();
#endif